//
// NES emu  PSP̉˂(XN[)
//
#include "screenmanager.h"
#include "nes/nes.h"
#include "debug/debug.h"
#include "main.h"
#include "pg.h"


uint16 g_Pal[256];	// palette index (using 0-63)
uint8 g_ScrBuf[NES_SCREEN_HEIGHTMAX][NES_BACKBUF_WIDTH]; // Screen palette index buffer


// pbgʒm pal[NES_MAX_COLORS][3]
void Scr_AssertPalette(uint8 pal[][3])
{
	int cbI;
	DEBUG("Scr_AssertPalette");
	_memset(g_Pal, 0x00, sizeof(g_Pal));
	for (cbI = 0; cbI < NES_NUM_COLORS; cbI++) {
		g_Pal[NES_COLOR_BASE + cbI] = RGB(pal[cbI][0], pal[cbI][1], pal[cbI][2]);
	}
}

// ʃ[h PAL or NTSC
void Scr_SetScreenMode(const unsigned char ScreenMode)
{
}

// w肵FœhԂ
void Scr_ClearScreen(const uint8 PalNum)
{
	int x,y;
	DEBUG("Scr_ClearScreen");
	_memset(g_ScrBuf, PalNum, sizeof(g_ScrBuf));
}

char g_szRenderMsg[80];
int g_nRenderMsgLen;
int g_nRenderMsgCount = 0;

// ʂɃbZ[W\p
void Scr_SetMessage(const char *pszMsg)
{
	_strncpy(g_szRenderMsg, pszMsg, sizeof(g_szRenderMsg) -1);
	g_szRenderMsg[79] = '\0';
	g_nRenderMsgLen=_strlen(g_szRenderMsg);
	g_nRenderMsgCount = 60;
}

// internal blt function - prototypes
void BitBlt_NormalScreen(void);
void BitBlt_FullScreen(void);
void BitBlt_X15(void);

// ʂ֓]
// VK[hǉ͏Ƀvg^Cv錾AScr_BltScreenswitchɒǉA
// BltScreen internal functions ̂Ƃɏ
// screenmanager.h enumaszScreenNameɒǉ΃j[Ή
void Scr_BltScreen(void)
{
	if(g_nRenderMsgCount==1 || g_nRenderMsgCount==2 || g_nRenderMsgCount==59 || g_nRenderMsgCount==60) pgFillBox(0,263,479,271,0);

	// pbgƃobt@ʂ֕`揈
	switch(setting.screenmode) {
	case SCREEN_FULL:       BitBlt_FullScreen();       break;
	case SCREEN_X15:		BitBlt_X15();				break;
	default:                BitBlt_NormalScreen();     break; // SCREEN_NORMAL
	}
	// draw message
	if(g_nRenderMsgCount>=3){
		pgFillBox(0,263,g_nRenderMsgLen*8,271,0);
		pgPrint(0,33,0xffff,g_szRenderMsg);
	}
	if(g_nRenderMsgCount>0) g_nRenderMsgCount--;
	// draw fps
	if (setting.showfps) {
		extern uint32 g_ulFPS;	// emu_main.c
		char szFPS[32];
		_itoa(g_ulFPS, szFPS);
		_strcat(szFPS, "FPS");
		pgFillBox(0,0,_strlen(szFPS)*8,8,0);
		pgPrint(0,0,0xffff,szFPS);
	}
}

// `惍bN
boolean Scr_Lock(pixmap *p)
{
	p->height = NES_SCREEN_HEIGHTMAX;
	p->width  = NES_BACKBUF_WIDTH;
	p->pitch  = NES_BACKBUF_WIDTH;
	p->bitdepth = 0;
	p->Gbitmask = 0;
	p->data = &g_ScrBuf[0][0];
	return TRUE;
}

// `AbN
void Scr_Unlock(void)
{
}







/////////////////////////////////////////////////
// BltScreen internal functions

//Parallel blend
static inline unsigned long PBlend(unsigned long c0, unsigned long c1)
{
	return (c0 & c1) + (((c0 ^ c1) & 0x7bde7bde) >> 1);
}

void BitBlt_NormalScreen(void)
{
	int x,y;
	unsigned short *pVram;
	pVram = (unsigned short *)pgGetVramAddr(0, 0) + 112 + 30 * LINESIZE;
	for (y = 0; y < 224; y++) {
		for (x = 0; x < 256; x++) {
			pVram[x] = g_Pal[g_ScrBuf[y + 8][x + 8]];
		}
		pVram += LINESIZE;
	}
}

//[8hbgĊg
void BitBlt_FullScreen(void)
{
	int x,y, dy = 0;
	unsigned long *pVram;
	pVram = (unsigned long *)pgGetVramAddr(0, 0);
	for (y = 0; y < 224; y++) {
		for (x = 0; x < 240; x+=2) {
			cpy2x(&pVram[x], (g_Pal[g_ScrBuf[y + 8][x + 16 + 1]] << 16) + g_Pal[g_ScrBuf[y + 8][x + 16]]);
		}
		pVram += (LINESIZE/2);
		dy += 21429;
		if (dy >= 100000) {
			dy-=100000;
			for (x = 0; x < 240; x+=2) {
				unsigned long ulColor = PBlend((g_Pal[g_ScrBuf[y + 8    ][x + 16 + 1]] << 16) + g_Pal[g_ScrBuf[y + 8    ][x + 16]],
									         (g_Pal[g_ScrBuf[y + 8 + 1][x + 16 + 1]] << 16) + g_Pal[g_ScrBuf[y + 8 + 1][x + 16]]);
				cpy2x(&pVram[x], ulColor);
			}
			pVram += (LINESIZE/2);
		}
	}
}

// 1line x1.5 g
static inline unsigned char* _X15(unsigned long *pVram, unsigned char *src){
	unsigned long x;
	
	for (x = NES_SCREEN_WIDTH/4; x > 0; x--) {
		unsigned long t0, t1, t2, col;

		t0  = g_Pal[src[0]];
		t1  = g_Pal[src[1]];
		t1 |= g_Pal[src[2]]<<16;
		t0 |= g_Pal[src[3]]<<16;
		t2  = PBlend(t0, t1);
		*pVram     = (t0&0xffff)|(t2<<16);
		*(pVram+1) = t1;
		*(pVram+2) = (t2>>16)|(t0&0xffff0000);

		pVram+=3;
		src+=4;
	}
	return src+2*SIDE_MARGIN;
}

// 2line x1.5 g & 2lineline v3lineo
static inline unsigned char* _X15_Blend(unsigned long *pVram, unsigned char *src){
	unsigned long x;
	
	for (x = NES_SCREEN_WIDTH/4; x > 0; x--) {
		unsigned long t0, t1, t2, t3, t4, t5, next;
		next=2*SIDE_MARGIN+NES_SCREEN_WIDTH;

		t3  = g_Pal[src[0]];
		t1  = g_Pal[src[1]];
		t1 |= g_Pal[src[2]]<<16;
		t3 |= g_Pal[src[3]]<<16;
		t2  = PBlend(t3, t1);
		
		t0  = (t3&0xffff)|(t2<<16);
		t2  = (t2>>16)|(t3&0xffff0000);
		
		t3  = g_Pal[src[0+next]];
		t4  = g_Pal[src[1+next]];
		t4 |= g_Pal[src[2+next]]<<16;
		t3 |= g_Pal[src[3+next]]<<16;
		t5  = PBlend(t3, t4);
		
		*(pVram+1) 				= t1;
		*(pVram+1+LINESIZE/2)	= PBlend(t1, t4);
		*(pVram+1+LINESIZE)		= t4;
		
		t1  = (t3&0xffff)|(t5<<16);
		t5  = (t5>>16)|(t3&0xffff0000);
		
		*(pVram) 				= t0;
		*(pVram+LINESIZE/2)		= PBlend(t0, t1);
		*(pVram+LINESIZE)		= t1;
		
		*(pVram+2) 				= t2;
		*(pVram+2+LINESIZE/2)	= PBlend(t2, t5);
		*(pVram+2+LINESIZE)		= t5;
		

		pVram+=3;
		src+=4;
	}
	return src+4*SIDE_MARGIN+NES_SCREEN_WIDTH;
}

//WIDTH x1.5
void BitBlt_X15(void)
{
	unsigned long x, y;
	unsigned long *pVram;
	unsigned char *src;

	pVram = (unsigned long *)pgGetVramAddr((480-256*3/2)/2, 0);
	src = (unsigned char*)&g_ScrBuf[8][8];
	
	for (y = 16; y > 0; y--) {
		src   = _X15( pVram, src);
		pVram += LINESIZE/2;

		src   =_X15_Blend( pVram, src);
		pVram += LINESIZE/2*3;
		
		for(x=3; x >0; x-- ){
			src   =_X15( pVram, src);
			pVram += LINESIZE/2;
		}
		
		src   =_X15_Blend( pVram, src);
		pVram += LINESIZE/2*3;
		
		for(x=3; x >0; x-- ){
			src   =_X15( pVram, src);
			pVram += LINESIZE/2;
		}
		
		src   =_X15_Blend( pVram, src);
		pVram += LINESIZE/2*3;
		
		src   =_X15( pVram, src);
		pVram += LINESIZE/2;
	}
}








/*
/////////////////////////////////////////////////
// Deflate/Inflate

// TlCkpɍUnziplib̃R[hRgAEgĂ
// unziplibzipkΉ܂ŃRgAEgƂ

size_t DeflateData(void *pOut, void *pIn, size_t inSize)
{
	z_stream zStream;
	_memset(&zStream, 0x00, sizeof(zStream));
	deflateInit(&zStream, Z_DEFAULT_COMPRESSION);

	zStream.next_in = pIn;
	zStream.avail_in = inSize;
	zStream.next_out = pOut;
	zStream.avail_out = inSize;

	int nRet = deflate(&zStream, Z_FINISH);

	deflateEnd(&zStream);
	return zStream.avail_out;
}

size_t InflateData(void *pOut, size_t outSize, void *pIn, size_t inSize)
{
	z_stream zStream;
	_memset(&zStream, 0x00, sizeof(zStream));
	inflateInit(&zStream);

	zStream.next_in = pIn;
	zStream.avail_in = inSize;
	zStream.next_out = pOut;
	zStream.avail_out = outSize;

	int nRet = inflate(&zStream, Z_NO_FLUSH);
	deflateEnd(&zStream);
	return zStream.avail_out;
}
*/

/////////////////////////////////////////////////
// thumbnail
// 128x112A16BitŒłB

#define THUMB_RGBMASK 0x1CE7	// = 0BBBBBGGGGGRRRRR = 0001110011100111B

// create thumbnail
boolean CreateThumnailFile(char *szThumbnailPath)
{
	// [J(H)
	uint16 thumbnail[112][128];
	int x,y;
	// create thumbnail forom palette and index buffer.
	for (y = 0; y < 224; y+=2) {
		for (x = 0; x < 256; x+=2) {
			// ŋߖT@͓RʂÂŐ`Ԗ@ɕύX
			// \͈͔щzĂ邪X\͈͈ȏ̃obt@̂Ŗ
			//thumbnail[y/2][x/2] = g_Pal[g_ScrBuf[y + 8][x + 8]];
			thumbnail[y/2][x/2] =
				((g_Pal[g_ScrBuf[y + 8  ][x + 8  ]] >> 2) & THUMB_RGBMASK)+
				((g_Pal[g_ScrBuf[y + 8  ][x + 8+1]] >> 2) & THUMB_RGBMASK)+
				((g_Pal[g_ScrBuf[y + 8+1][x + 8  ]] >> 2) & THUMB_RGBMASK)+
				((g_Pal[g_ScrBuf[y + 8+1][x + 8+1]] >> 2) & THUMB_RGBMASK);
		}
	}
	// output file
	HANDLE hFile = NES_fopen(szThumbnailPath, FILE_MODE_WRITE);
	if (hFile >= 0) {
		int nWriteSize = NES_fwrite(thumbnail, sizeof(thumbnail), 1, hFile);
		NES_fclose(hFile);
		if (nWriteSize == sizeof(thumbnail)) return TRUE;
		// eʕsۂ̂ŁAS~f[^j
		sceIoRemove(szThumbnailPath);
	}
	return FALSE;
}

// load thumbnail
boolean LoadThumnailFile(char *szThumbnailPath, uint16 *pBuf)
{
	// load file
	HANDLE hFile = NES_fopen(szThumbnailPath, FILE_MODE_READ);
	if (hFile >= 0) {
		NES_fread(pBuf, sizeof(uint16)*128*112, 1, hFile);
		// Readsize == sizeof(uint16)*128*112 Ȃ񈳏kTlC
		NES_fclose(hFile);
		return TRUE;
	}
	return FALSE;
}
